=== debian/changelog ===
ros-ardent-fastcdr (1.0.6-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Sat, 09 Dec 2017 05:50:57 -0000
