=== debian/control ===
Source: ros-ardent-fastcdr
Section: misc
Priority: extra
Maintainer: Steven! Ragnarök <stevenragnarok@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-ardent-ament-cmake, ros-ardent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-ardent-fastcdr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-ardent-ros-workspace
Description: CDR serialization implementation.
